import func
import os
import time
import shutil

rootPath = os.path.dirname(os.path.abspath(__file__))
os.chdir(rootPath)
with open("filePath.txt", "r") as f:
    projectPath = f.readline().strip()  # CPU目录
    xilinxPath = f.readline().strip()  # ise下载地址
    resultPath = f.readline().strip() # result输出地址  
    project2Path = " "
    checkmode = 0
    try :
        checkmode = int(f.readline().strip()) # 测试模式
        assert checkmode == 1
        print("当前模式：两人对拍\n")
    except :
        print("当前模式：与mars对拍\n")
        print("若想进入两人对拍模式，请在filePath的第四行输入1，第五行输入第二个人的cpu目录\n")
    if (checkmode == 1) :
        try :
            project2Path = f.readline().strip() # 另一个cpu目录
            assert project2Path != ""
        except :
            print("第二人的cpu目录缺失")
            print("若想进入两人对拍模式，请在filePath的第四行输入1，第五行输入第二个人的cpu目录")
            os._exit(0)
if (projectPath == "" or resultPath == "" or xilinxPath == "") :
    print("地址设置错误或地址设置不完整")
    print("filePath.txt 文件中应有三行, 分别为")
    print(".v文件的目录(确保不含testbench)")
    print("ise的下载目录(一般以 D:/ISE/14.7/ISE_DS/ISE 开头)")
    print("测评结果文件夹的输出目录(假设目录为D:, 则最终结果会在D:/result 文件夹中)")
    print('''示例如下:
C:/Users/tree/Desktop/P5/CPU/
D:/ISE/14.7/ISE_DS/ISE
D:\python_code\myCoKiller\coKiller
注意！请不要包含中文路径！！''')
    temp = input("按回车结束程序")
    os._exit(0)
if (projectPath[-1] != '/') :
    projectPath += '/'
if (project2Path[-1] != '/') :
    project2Path += '/'
if (xilinxPath[-1] != '/') :
    xilinxPath += '/'
if (resultPath[-1] != '/') :
    resultPath += '/'

print("CPU目录(.v文件目录)为: " + projectPath + "\n")
print("ise下载地址为: " + xilinxPath + "\n")
print("测评结果输出地址为: " + resultPath + "\n")
if (checkmode == 1) :
    print("第二人的CPU目录为: " + project2Path + "\n")
temp = input("若以上地址有误, 输入n结束程序, 在filePath.txt中设置好路径后再次运行此程序\n若以上地址确认无误, 请按回车\n")
if temp.isspace() or len(temp) == 0:
    print("开始运行")
else :
    os._exit(0)

resultPath += "result/"  # 所有生成的文件的目录

if not os.path.isdir(resultPath):
    try:
        os.makedirs(resultPath)
        os.chmod(resultPath, 0o755)  # 设置目录权限为755
        print("目录创建成功，并设置了权限")
    except PermissionError:
        print("当前进程无权限在目标目录中创建子目录或删除文件")
        # 执行相应的错误处理逻辑
        temp = input("按回车继续")



asmFilename = "testcode.asm"
hexFilename = "hex.txt"
cpuOutputFilename = "cpuOutput.txt"
cpuOutput2Filename = "cpuOutput2.txt"
marsOutputFilename = "marsOutput.txt"
htmlFilename = "diff.html"
coverageFilename = "coverage.json"
cycleFilename = "cycle.txt"

coveragePath = "analyzer.py"  # 覆盖率测试文件地址
dataMakerPath = "dataMaker.jar"  # 数据生成器目录
marsPath = "mars.jar"  # mars目录
asmPath = resultPath + asmFilename
hexPath = resultPath + hexFilename
marsOutputPath = resultPath + marsOutputFilename
cpuOutputPath = resultPath + cpuOutputFilename
cpuOutput2Path = resultPath + cpuOutput2Filename
cyclesPath = resultPath + cycleFilename
diffoutputPath = resultPath + htmlFilename
tempPath = resultPath + "temp.txt"

mode = 5
while(1):
    while (1):
        try:
            mode = input("请选择测试模式：输入5为P5, 输入6为P6, 输入7为P7, 按回车结束(默认为P5)\n")
            if (mode == "" or mode == '5') :
                dataMakerPath = "dataMaker5.jar"
                mode = 5
                break
            elif (mode == '6') :
                dataMakerPath = "dataMaker6.jar"
                mode = 6
                break
            elif (mode == '7') :
                # print("P7评测机还未完工，敬请期待！完成后会在讨论区更新")
                mode = 7
                break
            else :
                print("输入格式不正确")
        except:
            print("输入格式不正确")

    while(1):
        try:
            times = input("请输入你希望的测评次数（默认为10次），按回车继续：（最多100次）\n")
            if times == "" :
                times = 10
            if (int(times) < 0 or int(times) > 100):
                print("请输入一个1-100的整数，按回车结束")
            else :
                times = int(times)
                break
        except:
            print("请输入一个1-100的整数，按回车结束")
    print("本次测评次数：" + str(times))

    for i in range(1, times + 1) :
        print("\n开始第 %d 次测评\n"%i)
        if (times == 1) :
            test = input("测试testcode中存好的测试点(mips)请输入1，\
测试hex中存好的测试点(十六进制)请输入2, 否则创造新测试点，回车继续（默认创造新测试点）")
            if (test != "1" and test != "2") :
                try:
                    os.chdir(rootPath)
                    func.make_data(dataMakerPath, asmPath)
                    print("创造测试点成功！")
                except:
                    print("创建测试点失败, 请检查_internal文件夹中是否有dataMaker.jar文件, 或联系管理员")
                    temp = input("按回车继续")
                    os._exit(0)
                
                try:
                    os.chdir(rootPath)
                    func.mips_to_hex(marsPath, asmPath, hexPath)
                    print("测试点转十六进制成功!")
                except:
                    print("测试点转十六进制失败, 请检查_internal文件夹中是否有mars.jar文件, 或联系管理员")
                    temp = input("按回车继续")
                    os._exit(0)
            elif (test == "1") :
                try:
                    os.chdir(rootPath)
                    func.mips_to_hex(marsPath, asmPath, hexPath)
                    print("测试点转十六进制成功!")
                except:
                    print("测试点转十六进制失败, 请检查_internal文件夹中是否有mars.jar文件, 或联系管理员")
                    temp = input("按回车继续")
                    os._exit(0)
        else :
            try:
                os.chdir(rootPath)
                func.make_data(dataMakerPath, asmPath)
                print("创造测试点成功！")
            except:
                print("创建测试点失败, 请检查_internal文件夹中是否有dataMaker.jar文件, 或联系管理员")
                temp = input("按回车继续")
                os._exit(0)

            try:
                os.chdir(rootPath)
                func.mips_to_hex(marsPath, asmPath, hexPath)
                print("测试点转十六进制成功!")
            except:
                print("测试点转十六进制失败, 请检查_internal文件夹中是否有mars.jar文件, 或联系管理员")
                temp = input("按回车继续")
                os._exit(0)






        if (checkmode == 0) :
            try:
                os.chdir(rootPath)
                func.task(marsPath, asmPath, marsOutputPath, mode)
                # func.del0_in_mars(marsOutputPath)
                # func.get_mars_output(marsPath, asmPath, marsOutputPath, tempPath)
                print("利用魔改mars获取正确输出成功!")
            except:
                print("利用魔改mars获取正确输出失败, 请检查_internal文件夹中是否有mars.jar文件, 或联系管理员")
                temp = input("按回车继续")
                os._exit(0)

        try:
            # os.chdir(rootPath)
            func.load_files(hexPath, projectPath, int(mode))
            print("加载仿真预备文件成功!")
        except:
            print(mode)
            print("加载仿真预备文件失败, 请检查软件的权限, 或联系管理员")
            temp = input("按回车继续")
            os._exit(0)

        try:
            os.chdir(rootPath)
            func.execute_ise(projectPath, xilinxPath, cpuOutputPath)
            print("执行ise仿真成功！")
        except:
            print("执行ise仿真失败, 请检查ise安装路径是否正确,mips.v的端口是否符合p5要求, 或联系管理员")
            temp = input("按回车继续")
            os._exit(0)

        try:
            os.chdir(rootPath)
            mycycles = func.cope_cpu_out_file(cpuOutputPath)
            print("处理仿真结果成功！")
        except:
            print("处理仿真结果失败, 请注意P5教程中要求多输出一个时间$time, 或联系管理员")
            temp = input("按回车继续")
            os._exit(0)
        
        if (checkmode == 1) :
            time.sleep(1)
            try:
                os.chdir(rootPath)
                func.load_files(hexPath, project2Path, int(mode))
                print("加载第二人仿真预备文件成功!")
            except:
                print(mode)
                print("加载第二人仿真预备文件失败, 请检查软件的权限, 或联系管理员")
                temp = input("按回车继续")
                os._exit(0)

            try:
                os.chdir(rootPath)
                func.execute_ise(project2Path, xilinxPath, cpuOutput2Path)
                print("执行第二人ise仿真成功！")
            except:
                print("执行第二人ise仿真失败, 请检查ise安装路径是否正确,mips.v的端口是否符合p5要求, 或联系管理员")
                temp = input("按回车继续")
                os._exit(0)

            try:
                os.chdir(rootPath)
                mycycles = func.cope_cpu_out_file(cpuOutput2Path)
                print("处理第二人仿真结果成功！")
            except:
                print("处理第二人仿真结果失败, 请注意P5教程中要求多输出一个时间$time, 或联系管理员")
                temp = input("按回车继续")
                os._exit(0)
        
        
        # os.chdir(rootPath)
        # os.system("java -jar Hazard-Calculator.jar " + resultPath + hexFilename + " > " + resultPath + cycleFilename)
        # with open(resultPath + cycleFilename, "a") as f :
        #     f.write("\nyour cycle: " + str(int(mycycles)))
        # print("正在计算测试点的标准周期范围...")

        if (checkmode == 0) :
            try:
                os.chdir(rootPath)
                ratio = func.find_diffs(marsOutputPath, cpuOutputPath, diffoutputPath)
                print("比对mars与仿真结果的输出和周期数成功！\n")
                if (ratio == 1) :
                    print("测评结果：Accept！！\n")
                else :
                    print("测评结果：wrong answer！！请测评结束后查看result文件夹寻找问题\n")
            except:
                print("比对mars与仿真结果的输出和周期数失败, 请检查_internal文件夹中是否有Hazard-Calculator.jar文件, 或联系管理员")
                temp = input("按回车继续")
                os._exit(0)
        else :
            try:
                os.chdir(rootPath)
                ratio = func.find_diffs(cpuOutput2Path, cpuOutputPath, diffoutputPath)
                print("比对两人的输出成功！（左侧为第二人的输出）\n")
                if (ratio == 1) :
                    print("测评结果：Accept！！\n")
                else :
                    print("测评结果：wrong answer！！请测评结束后查看result文件夹寻找问题\n")
            except:
                print("比对两人的输出失败, 请联系管理员")
                temp = input("按回车继续")
                os._exit(0)

        # func.cal_coverage(hexPath, "P5_textcode")
        # os.chdir(rootPath)
        # os.system("python analyzer.py")
        # txt = ""
        # with open("coverage/P5_textcode_statistic_hazard.json", "r") as f :
        #     for line in f.readlines():
        #         txt += line

        # with open(resultPath + coverageFilename, "w") as f :
        #     f.write(txt)
        # print("正在计算测试点覆盖率...")
        
 

        print("第 %d 次测评完成! 所有测评结果可在result文件夹中查看"%i)

        if ratio != 1 or i == times:
            if (ratio != 1) :
                print("\n本次测评的结果为 wrong answer！！与标准结果相似度为%f\n"%ratio)
            while (1):
                op = input('''
                输入1查看比对结果(左侧为标准输出)
                输入2查看指令覆盖率（暂时无法查看）
                输入3查看标准与实际周期数对比
                输入4打开指令(mips)
                输入5打开指令(十六进制)
                输入6打开魔改mars输出结果
                输入7打开你的CPU的输出结果
                输入0继续测评(会覆盖的此次的result文件，建议先根据result中的结果debug后再回来)
                输入其他或无输入结束程序, 按回车结束
                ''')

                # print(resultPath)
                if (op == '0') :
                    break
                elif (op == '1') :
                    os.system("start " + resultPath + htmlFilename)
                elif (op == '2') :
                    os.system("start " + resultPath + coverageFilename)
                elif (op == '3') :
                    os.system("start " + resultPath + cycleFilename)
                elif (op == '4') :
                    os.system("start " + resultPath + asmFilename)
                elif (op == '5') :
                    os.system("start " + resultPath + hexFilename)
                elif (op == '6') :
                    os.system("start " + resultPath + marsOutputFilename)
                elif (op == '7') :
                    os.system("start " + resultPath + cpuOutputFilename)
                else :
                    os._exit(0)
    test = input("\n本轮测评结束,重新测评请输入0,否则退出程序, 按回车结束\n")
    if (test != '0') :
        os._exit(0)
    else :
        continue